@echo off
setlocal

:: Assuming the batch file is in the same directory as the Cinebench executable
set "CinebenchPath=Cinebench.exe"

:: Display menu for user to choose the test type
echo Please select the test you want to run:
echo 1. GPU Test
echo 2. Multi Core Test
echo 3. Single Core Test
echo 4. All Tests
echo.

set /P TestType="Enter your choice (1-4): "
echo.

:: Set test option based on user choice
set "TestOption="
if "%TestType%"=="1" set "TestOption=g_CinebenchGPUTest=true"
if "%TestType%"=="2" set "TestOption=g_CinebenchCpuXTest=true"
if "%TestType%"=="3" set "TestOption=g_CinebenchCpu1Test=true"
if "%TestType%"=="4" set "TestOption=g_CinebenchAllTests=true"

:: Ask for the number of runs
set /P runcount="Enter the number of runs you want to perform: "
if "%runcount%"=="" goto printUsage

:: Initialize output files
set "outputFile=cinebench_output.txt"
set "resultsFile=cinebench_results.txt"
echo Starting Cinebench loop... > "%outputFile%"

:: Start Cinebench execution loop
for /L %%i in (1,1,%runcount%) do (
  echo Cinebench Run #%%i >> "%outputFile%"
  start /b /wait cmd.exe /C "%CinebenchPath% %TestOption% g_CinebenchMinimumTestDuration=1 >> "%outputFile%" 2>&1"
  echo Pause for 10 seconds...
  timeout /t 10
)

:: Extract results from the output file and display them
echo:
echo Cinebench results: > "%resultsFile%"
echo ------------------ >> "%resultsFile%"
findstr /b "CB" "%outputFile%" >> "%resultsFile%"
type "%resultsFile%"
pause
exit /B 0

:: Display command-line usage
:printUsage
echo Invalid input or no run count provided.
echo Please restart the script and enter a valid number of runs.
pause
exit /B 1
